<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <meta http-equiv="Content-Style-Type" content="text/css">
  <title></title>
  <meta name="Generator" content="Cocoa HTML Writer">
  <meta name="CocoaVersion" content="1561.61">
  <style type="text/css">
    p.p1 {margin: 0.0px 0.0px 0.0px 0.0px; line-height: 15.0px; font: 13.0px Courier; color: #000000; -webkit-text-stroke: #000000}
    span.s1 {font-kerning: none}
  </style>
</head>
<body>
<p class="p1"><span class="s1">// Sample beaTlet for beaTunes 5.x</span></p>
<p class="p1"><span class="s1">// More info at https://www.beatunes.com/en/beatlet-keytextrenderer.html</span></p>
<p class="p1"><span class="s1">import com.tagtraum.audiokern.key.Key</span></p>
<p class="p1"><span class="s1">import com.tagtraum.beatunes.KeyTextRenderer</span></p>
<p class="p1"><span class="s1"><br>
</span></p>
<p class="p1"><span class="s1">class CustomKeyRenderer implements KeyTextRenderer {</span></p>
<p class="p1"><span class="s1"><br>
</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">    </span>/**</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>* Create a textual representation for a Key object.</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>*</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>* @param key key</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>* @return textual representation</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>*/</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">    </span>def String toKeyString(Key key) {</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">        </span>// key.ordinal() is a number starting with C Major = 0 and A Minor = 0,</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">        </span>// then following the order in the Circle of Fifths.</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">        </span>// Let's shift by 8 and make sure 0 is converted to 12.</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">        </span>int i = (key.ordinal() + 8) % 12</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">        </span>i = i == 0 ? 12 : i</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">        </span>String ab = key.isMajor() ? "A" : "B"</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">        </span>// create the final string</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">        </span>return "$i$ab"</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">    </span>}</span></p>
<p class="p1"><span class="s1"><br>
</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">    </span>/**</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>* Create a tooltip representation for a key object.</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>* This may also include html-tags.</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>*</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>* @param key key</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>* @return tooltip representation</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>*/</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">    </span>def String toToolTip(Key key) {</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">        </span>toKeyString(key)</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">    </span>}</span></p>
<p class="p1"><span class="s1"><br>
</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">    </span>/**</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>* Short name of this renderer. To be used in the user interface.</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>*</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>* @return name</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">     </span>*/</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">    </span>def String getName() {</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">        </span>"Custom.groovy"</span></p>
<p class="p1"><span class="s1"><span class="Apple-converted-space">    </span>}</span></p>
<p class="p1"><span class="s1"><br>
</span></p>
<p class="p1"><span class="s1">}</span></p>
</body>
</html>
